

GO
PRINT N'Modificando [dbo].[WorkGroupSupervisor]...';


GO
ALTER TABLE [dbo].[WorkGroupSupervisor]
    ADD [IsHistoric] BIT NULL;


GO
PRINT N'Modificando [dbo].[GetHistoricCampaigns]...';


GO
ALTER PROCEDURE [dbo].[GetHistoricCampaigns]
(@Vcc					VARCHAR(50), 
 @ExcludesWorkGroupSup	BIT 
)
AS
BEGIN	
	
	
WITH ResultCampaing AS (
		SELECT 
			[AU].[Campaign]  'id',
			[AU].[Campaign]  'campaign'
		FROM [dbo].[Audio] AU (NOLOCK)
		WHERE [AU].[VCC] = @Vcc
		AND (@ExcludesWorkGroupSup = 0
				OR
			(@ExcludesWorkGroupSup = 1 AND [AU].[Campaign] NOT IN (SELECT WKS.CampaignId FROM dbo.WorkGroupSupervisor WKS (NOLOCK) WHERE WKS.VCC = @Vcc))
			)
		UNION 
		SELECT 
			[IEP].[IdCampaign] AS 'id',
			[IEP].[IdCampaign] AS 'campaign'
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		WHERE [IEP].[Instance] = @Vcc
		AND (@ExcludesWorkGroupSup = 0
				OR
			(@ExcludesWorkGroupSup = 1 AND [IEP].[IdCampaign] NOT IN  (SELECT WKS.CampaignId FROM dbo.WorkGroupSupervisor WKS (NOLOCK) WHERE WKS.VCC = @Vcc))
			)
	)

	SELECT 
		R.id  'id', 
		R.campaign  'campaign' ,
		(
			SELECT STUFF((
				SELECT ',' + [idagent] + ''
				FROM (
					SELECT DISTINCT [AU2].[Agent]  'idagent'
					FROM [dbo].[Audio] AU2 (NOLOCK)
					WHERE [AU2].[VCC] = @Vcc AND [AU2].[Campaign] = R.id

					UNION

					SELECT DISTINCT [IE2].[IdAgent]  'idagent'
					FROM [dbo].[InteractionEvaluationPlan] IE2 (NOLOCK)
					WHERE [IE2].[Instance] = @Vcc AND [IE2].[IdCampaign] = R.id
				) agents
				FOR XML PATH(''), TYPE
			).value('.', 'NVARCHAR(MAX)'), 1, 1, '') 
		) AS 'agents'
	FROM ResultCampaing R
END
GO
PRINT N'Modificando [dbo].[GetWorkGroupsSupervisor]...';


GO
ALTER PROCEDURE [dbo].[GetWorkGroupsSupervisor] (
	@VCC Varchar(50) = NULL, 
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT DISTINCT
		[Description]					'description',
		[SupervisorId]                  'supervisorId',
		[IsHistoric]					'isHistoric'
	FROM [WorkGroupSupervisor] (NOLOCK)
	WHERE [VCC] = @VCC
		AND ISNULL([Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL([SupervisorId], '') LIKE CASE WHEN @SearchCriteria = 'supervisor' THEN '%' + @SearchExpression + '%' ELSE '%' END
		
		
	SET NOCOUNT OFF
END

PRINT N'Update complete.';
GO
PRINT N'Modificando [dbo].[GetWorkGroupSupervisor]...';


GO
ALTER PROCEDURE [dbo].[GetWorkGroupSupervisor] (
	@VCC Varchar(50) = NULL, @SupervisorId Varchar(250) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[Description]					'description',
		[SupervisorId]					'supervisorId',
		[CampaignID]					'campaignId',
		[agentId]					    'agentId',
		[IsHistoric]					'isHistoric'
		
	FROM [WorkGroupSupervisor] (NOLOCK)
	WHERE [VCC] = @VCC
    AND [SupervisorId] = @SupervisorId
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveWorkGroupSupervisor]...';


GO
ALTER PROCEDURE [dbo].[SaveWorkGroupSupervisor] (
	@VCC Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@SupervisorId Varchar(250) = NULL,
	@CampaignId Varchar(250) = NULL,
	@AgentId Varchar(250) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@IsHistoric BIT = NULL
)
AS
BEGIN
	SET NOCOUNT ON

		INSERT INTO [WorkGroupSupervisor] (
			[VCC], [Description], [SupervisorId], 
			[CampaignId], [AgentId],[CreatedDate], [CreatedByUserId], 
			[LastModifiedDate], [LastModifiedByUserId], [TimeStamp], [IsHistoric]
			)
		VALUES (
			@VCC, @Description, @SupervisorId,
			@CampaignId, @AgentId,@CreatedDate, @CreatedByUserId, 
			@LastModifiedDate, @LastModifiedByUserId, GETUTCDATE(), @IsHistoric
		)
		
	
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetHistoricAgents]...';


GO
ALTER PROCEDURE [dbo].[GetHistoricAgents] 
(
	@Vcc					VARCHAR(50) = NULL, 
	@ExcludesWorkGroupSup	BIT 
) 
AS
BEGIN
	WITH ResultAgent AS (	
		SELECT 
			[AU].[Agent]  'id',
			[AU].[Agent]  'description'
		FROM [dbo].[Audio] AU (NOLOCK)
		WHERE [AU].[VCC] = @Vcc
		AND (@ExcludesWorkGroupSup = 0
				OR
			(@ExcludesWorkGroupSup = 1 AND [AU].[Agent] NOT IN (SELECT WKS.AgentId FROM dbo.WorkGroupSupervisor WKS (NOLOCK) WHERE WKS.VCC = @Vcc))
			)
		UNION 
		SELECT 
			[IEP].[IdAgent] AS 'id',
			[IEP].[IdAgent] AS 'description'
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		WHERE [IEP].[Instance] = @Vcc
		AND (@ExcludesWorkGroupSup = 0
				OR
			(@ExcludesWorkGroupSup = 1 AND [IEP].[IdAgent] NOT IN  (SELECT WKS.AgentId FROM dbo.WorkGroupSupervisor WKS (NOLOCK) WHERE WKS.VCC = @Vcc))
			)
	)

	SELECT 
		R.id AS 'id', 
		R.description AS 'description' ,
		(
			SELECT STUFF((
				SELECT ',' + [idcampaign] + ''
				FROM (
					SELECT DISTINCT [AU2].[Campaign] AS 'idcampaign'
					FROM [dbo].[Audio] AU2 (NOLOCK)
					WHERE [AU2].[VCC] = @Vcc AND [AU2].[Agent] = R.id

					UNION

					SELECT DISTINCT [IE2].[IdCampaign] AS 'idcampaign'
					FROM [dbo].[InteractionEvaluationPlan] IE2 (NOLOCK)
					WHERE [IE2].[Instance] = @Vcc AND [IE2].[IdAgent] = R.id
				) campaigns
				FOR XML PATH(''), TYPE
			).value('.', 'NVARCHAR(MAX)'), 1, 1, '') 
		) AS 'campaigns'
	FROM ResultAgent R

	
END

GO
PRINT N'Actualización completada.';


GO
