PRINT N'Iniciando recompilación de la tabla [dbo].[HistoricAbility]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_HistoricAbility] (
    [VCC]            VARCHAR (50)   NOT NULL,
    [ID]             VARCHAR (50)   NOT NULL,
    [Title]          VARCHAR (100)  NULL,
    [Detail]         VARCHAR (500)  NULL,
    [Type]           VARCHAR (50)   NULL,
    [Binary]         BIT            NULL,
    [NotApply]       BIT            NULL,
    [Distribute]     BIT            NULL,
    [AcceptComments] BIT            NULL,
    [Enabled]        BIT            NULL,
    [AnalysisType]   VARCHAR (25)   NULL,
    [Query]          VARCHAR (1000) NULL,
    [QueryName]      VARCHAR (50)   NULL,
    [Language]       VARCHAR (50)   NULL,
    [IsNegative]     BIT            NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK__Historic__A6FE7C3D9FB8F1BC1] PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[HistoricAbility])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_HistoricAbility] ([VCC], [ID], [Title], [Detail], [Type], [Binary], [NotApply], [Distribute], [AcceptComments], [Enabled], [AnalysisType], [Query], [QueryName], [Language], [IsNegative])
        SELECT   [VCC],
                 [ID],
                 [Title],
                 [Detail],
                 [Type],
                 [Binary],
                 [NotApply],
                 [Distribute],
                 [AcceptComments],
                 [Enabled],
                 [AnalysisType],
                 [Query],
                 [QueryName],
                 [Language],
                 [IsNegative]
        FROM     [dbo].[HistoricAbility]
        ORDER BY [VCC] ASC, [ID] ASC;
    END

DROP TABLE [dbo].[HistoricAbility];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_HistoricAbility]', N'HistoricAbility';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK__Historic__A6FE7C3D9FB8F1BC1]', N'PK__Historic__A6FE7C3D9FB8F1BC', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Modificando [dbo].[GetAudiosProcess]...';


GO
-- [dbo].[GetAudiosProcess] 5, 1, 'allegro', 'proceso1', '', '2019-04-11 00:00:00.000', '2019-06-06 04:59:59.997', 22, 26, 23, 59, 'entrantes,PruebasJair,VideoCall', 'icagente', NULL, 'allegro', '', ''
ALTER PROCEDURE [dbo].[GetAudiosProcess]
(
	@PageSize				INT,
	@PageNumber				INT,
	@VCC					VARCHAR(50),
	@ProcessId				VARCHAR(50),
	@ID						VARCHAR(250),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				INT,
	@StartMinute			INT,
	@EndHour				INT,
	@EndMinute				INT,
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
	@Type					VARCHAR(50),
	@IdathaResults			NVARCHAR(MAX),
	@TotalIdathaResults		INT,
	@InteractionType		VARCHAR(50),
	@InteractionIds         VARCHAR(MAX) = NULL,
	@Folder					VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	-- DEFINIMOS UNA TABLE TEMPORAL PARA DEPOSITAR LA TODOS LAS INTERACCIONES DEL PROCESS
	CREATE TABLE #PROCESS_INTERACTIONS(
		vcc VARCHAR(50),
		interactionType VARCHAR(100),
		id VARCHAR(250),
		section VARCHAR(5),
		part VARCHAR(5),
		processId VARCHAR(100),
		number VARCHAR(100),
		name VARCHAR(100),
		silenceTime INT,
		durationTime INT,
		durationLinguisticTime INT,
		category1 VARCHAR(100),
		category2 VARCHAR(100),
		category3 VARCHAR(100),
		agent VARCHAR(100),
		agentName VARCHAR(150),
		description VARCHAR(100),
		environment VARCHAR(100),
		isTranscribed VARCHAR(100),
		errorMessage VARCHAR(100),
		createdDate DATETIME,
		endDate DATETIME,
		campaign VARCHAR(50),
		dispositionCode VARCHAR(250),
		folder VARCHAR(50)
	)

	-- INSERTAMOS LOS REGISTROS CALL
	INSERT INTO #PROCESS_INTERACTIONS
		SELECT A.[VCC]														'vcc',
				'CALL'														'interactionType',
				A.[ID]														'id',
				A.[Section]													'section',
				A.[Part]													'part',
				PA.[ProcessId]												'processId',
				A.[Number]													'number',
				P.[Name]													'name',
				A.[SilenceTime]												'silenceTime',
				A.[DurationTime]											'durationTime',
				A.[DurationLinguisticTime]									'durationLinguisticTime',
				A.[Category1]												'category1',
				A.[Category2]												'category2',
				A.[Category3]												'category3',
				A.[Agent]													'agent',
				A.[AgentName]												'agentName',
				A.[Description]												'description',
				P.[Environment]												'environment',
				A.[IsTranscribed]											'isTranscribed',
				A.[ErrorMessage]											'errorMessage',
				A.[CreatedDate]												'createdDate',
				A.[EndDate]													'endDate',
				A.[Campaign]												'campaign',
				A.[DispositionCode]											'dispositionCode',
				NULL														'folder'
			FROM [dbo].[Audio] A (NOLOCK)
			INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON A.[VCC] = PA.[VCC]
					AND A.ID = PA.AudioId 
					AND A.Section = PA.Section 
					AND A.Part = PA.Part
			INNER JOIN [dbo].[Process] P (NOLOCK) 
				ON P.[VCC] = PA.[VCC]
					AND PA.[ProcessId] = P.[Name]
			WHERE A.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId
				AND P.[Type] = 'SPEECH'
				
	-- INSERTAMOS LOS REGISTROS DE INTERACCIONES DE OTROS CANALES
	INSERT INTO #PROCESS_INTERACTIONS
		SELECT AI.[VCC]																'vcc',
				AI.[Channel]														'interactionType',
				AI.[ID]																'id',
				NULL																'section',
				NULL																'part',
				PAI.[ProcessId]														'processId',
				AI.[ContactName]													'number',
				PAI.[ProcessId]														'name',
				NULL																'silenceTime',
				CASE WHEN TRY_CAST(AI.[DurationTime] AS INT) IS NULL THEN
					CAST(SUBSTRING(AI.[DurationTime], 1, CHARINDEX(':', AI.[DurationTime], 1) - 1) AS INT) * 3600
					+
					CAST(SUBSTRING(AI.[DurationTime], CHARINDEX(':', AI.[DurationTime], 1) + 1, 2) AS INT) * 60
					+
					CAST(SUBSTRING(AI.[DurationTime], CHARINDEX(':', AI.[DurationTime], CHARINDEX(':', AI.[DurationTime], 1) + 1) + 1, 2) AS INT)
				ELSE AI.[DurationTime]
				END																	'durationTime',
				NULL																'durationLinguisticTime',
				NULL																'category1',
				NULL																'category2',
				NULL																'category3',
				AI.[FirstTakedAgent]												'agent',
				ISNULL(AI.[LastTakedAgentName], AI.[LastTakedAgentName])			'agentName',
				AI.[DispositionCode]												'description',
				'I6'																'environment',
				AI.[IsTranscribed]													'isTranscribed',
				AI.[ErrorMessage]													'errorMessage',
				AI.[CreatedDate]													'createdDate',
				AI.[EndDate]														'endDate',
				AI.[Campaign]														'campaign',
				AI.[DispositionTreePath]											'dispositionCode',
				AI.[Folder]															'folder'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC]
					--AND AI.[Campaign] = PAI.[Campaign]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Folder] = PAI.[FormattedEndDate]
			INNER JOIN [dbo].[Process] P (NOLOCK) 
				ON P.[VCC] = PAI.[VCC]
					AND P.[Name] = PAI.[ProcessId]
			WHERE PAI.[VCC] = @VCC
				AND PAI.[ProcessId] = @ProcessId
				AND P.[Type] = 'SPEECH'
		
	-- DECLARAMOS VARIABLE PARA LA CONSULTA ACUMULADA QUE LANZAREMOS
	DECLARE @SQL NVARCHAR(MAX) = ''
	DECLARE @SQL_WHERE_IDATHA NVARCHAR(MAX) = ''
    DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''
	DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX )= ''	
	
	SET @SQL_WHERE_IDATHA = ''

	-- HACEMOS EL PRIMER QUERY PARA SACAR EL NUMERO DE REGISTROS DEL PROCESS
	SET @SQL = ' SET NOCOUNT ON
	DECLARE @rows INT
	DECLARE @SYNC_INTERACTIONS INT
	DECLARE @ASYNC_INTERACTIONS INT
	DECLARE @maxDurationTime Numeric(12,3)

	SELECT @SYNC_INTERACTIONS = COUNT(*) FROM #PROCESS_INTERACTIONS PI WHERE PI.[interactionType] = ''CALL''
	SELECT @ASYNC_INTERACTIONS = COUNT(*) FROM #PROCESS_INTERACTIONS PI WHERE PI.[interactionType] <> ''CALL''
	SELECT @maxDurationTime = MAX([durationTime]) FROM #PROCESS_INTERACTIONS 
	'

	SET @SQL += '
		SET @rows = (
			SELECT COUNT(PI.[id])
				FROM #PROCESS_INTERACTIONS PI (NOLOCK)
				WHERE PI.[vcc] = ''' + @VCC + ''' 
					'
	IF (@ProcessId IS NOT NULL) 
			SET @SQL += 'AND PI.[ProcessId]= ''' + @ProcessId + ''' 
						'

	IF(@Type = 'query')
	BEGIN
		SET @SQL_WHERE_IDATHA += 'AND ((CONCAT(PI.[id], ''_'', PI.[section], ''_'', PI.[part]) IN (''' + @IdathaResults + '''))
						OR (PI.[id] IN (''' + @IdathaResults + ''')))
					'
	
		SET @SQL += @SQL_WHERE_IDATHA

	END
	ELSE IF(@Type = 'allegro' OR @Type = 'ftp' OR @Type = 'sftp' OR @Type = 'fileSystem')
	BEGIN
		IF (@ID IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND ((CONCAT(PI.[id], ''_'', PI.[section], ''_'', PI.[part]) LIKE ''%' + @ID + '%'')
						OR (PI.[id] = ''' + @ID + '''))
					'
		
		IF (@Campaign IS NOT NULL AND LEN(@Campaign) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[campaign] IN (''' + @Campaign + ''')
						'
		
		IF (@Agent IS NOT NULL AND LEN(@Agent) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND (
									(PI.[agent] IN (''' + @Agent + '''))
									OR 
									(PI.[agent] IS NULL)
								)
						'
		
		--CORREGIR
		-- (CONCAT(PI.campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), PI.[dispositionCode]), '''') IN (''' + @ResultCode + '''))
		IF (@ResultCode IS NOT NULL AND LEN(@ResultCode) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND (
									(CONCAT(PI.campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), PI.[dispositionCode]), ''X'')) IN (''' + @ResultCode + '''))
									OR 
									--(CONCAT(PI.campaign, ''_'', ISNULL(PI.[dispositionCode], ''X'')) IN (''' + @ResultCode + '''))
									(CONCAT(PI.campaign, ISNULL(REPLACE(PI.[dispositionCode], ''/'', ''_''), ''_'')) IN (''' + @ResultCode + '''))
									) '
		
		IF (@InteractionType IS NOT NULL AND LEN(@InteractionType) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[interactionType] = ''' + @InteractionType + ''' 
						'

		IF (@Folder IS NOT NULL AND LEN(@Folder) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[folder] = ''' + @Folder + ''' 
						'

		IF (@Folder IS NOT NULL AND LEN(@Folder) > 0) 

		IF (@StartDate IS NOT NULL AND @EndDate IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[endDate] BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' 
						AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
						'
		
		IF (@StartHour IS NOT NULL AND @EndHour IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND DATEPART(HOUR, PI.[endDate]) >= ' + CONVERT(VARCHAR, @StartHour) + ' 
						AND DATEPART(HOUR, PI.[endDate]) <= ' + CONVERT(VARCHAR, @EndHour) + '
						'
		
		IF (@StartMinute IS NOT NULL AND @EndMinute IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND DATEPART(MINUTE, PI.[endDate]) >= ' + CONVERT(VARCHAR, @StartMinute) + ' 
						AND DATEPART(MINUTE, PI.[endDate]) <= ' + CONVERT(VARCHAR, @EndMinute) + '
						'

		IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
        BEGIN
			SET @FILTERS_OPTIONAL_PART = ''
			-- SET @FILTERS_EXCLUDING_PART = ' AND PI.[id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) 
			--			'
			SET @FILTERS_EXCLUDING_PART = ' AND (
						(CONCAT(PI.[id], ''_'', PI.[section], ''_'', PI.[part]) IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')))
						OR 
						(PI.[id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')))
						)
						'
	    END
		
	END

	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART
	SET @SQL += ') '
	SET @SQL += 'SELECT @rows AS total, 
						@maxDurationTime AS maxDurationTime,
						@ASYNC_INTERACTIONS AS asyncDetails, 
						@SYNC_INTERACTIONS AS audios '

	-- SECCION DE QUERY PARA RESUMEN DE CANALES
	SET @SQL += '
		SELECT PI.[interactionType]			''interactionType'',
				COUNT(*)					''interactions'' 
			FROM #PROCESS_INTERACTIONS PI 
			WHERE PI.[vcc] = ''' + @VCC + ''' 
	'

	IF(@ProcessId IS NOT NULL) 
		SET @SQL += '
				AND PI.[processId] = ''' + @ProcessId + ''' '
		
	SET @SQL += '
		GROUP BY  PI.[interactionType] '

	-- SECCION DE QUERY PARA RESUMEN DE CAMPANAS
	SET @SQL += '
		SELECT PI.[campaign]			''campaign''
			FROM #PROCESS_INTERACTIONS PI 
			WHERE PI.[vcc] = ''' + @VCC + ''' 
	'

	IF(@ProcessId IS NOT NULL) 
		SET @SQL += '
				AND PI.[processId] = ''' + @ProcessId + ''' '
		
	SET @SQL += '
		GROUP BY  PI.[campaign] '

	-- SECCION DE QUERY PARA LISTADO DE DETALLES(AUDIOS/TEXTOS)
	SET @SQL += '
		SELECT PI.[interactionType],
				PI.[id],
				PI.[section],
				PI.[part],
				PI.[processId],
				PI.[folder],
				PI.[campaign],
				PI.[number],
				PI.[name],
				PI.[silenceTime],
				PI.[durationTime],
				PI.[durationLinguisticTime],
				PI.[category1],
				PI.[category2],
				PI.[category3],
				PI.[agent],
				PI.[agentName],
				PI.[description],
				PI.[environment],
				PI.[isTranscribed],
				PI.[errorMessage],
				PI.[createdDate],
				PI.[endDate]
			FROM #PROCESS_INTERACTIONS PI
			WHERE PI.[vcc] = ''' + @VCC + ''' 
				'

	IF(@ProcessId IS NOT NULL) SET @SQL += 'AND PI.[processId] = ''' + @ProcessId + ''' '
			
	SET @SQL += ' '

	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART
	SET @SQL += @SQL_WHERE_IDATHA
	SET @SQL += 'ORDER BY PI.[ID], 
						PI.[ProcessId], 
						PI.[Agent], 
						PI.[AgentName], 
						PI.[Description], 
						PI.[Environment], 
						PI.[DurationTime], 
						PI.[CreatedDate]
			OFFSET ' + CONVERT(VARCHAR(50), @PageSize) + ' * (' + CONVERT(VARCHAR(50), @PageNumber) + ' - 1) ROWS
			FETCH NEXT ' + CONVERT(VARCHAR(50), @PageSize) + ' ROWS ONLY
			'

	SET @SQL += ' SET NOCOUNT OFF'
	-- select @SQL
	EXEC(@SQL)
	
	DROP TABLE #PROCESS_INTERACTIONS
END
GO
PRINT N'Modificando [dbo].[LaunchAudioConverter]...';


GO
ALTER PROCEDURE [dbo].[LaunchAudioConverter] (
	@VCC VARCHAR(50) = NULL, 
	@APP_PATH VARCHAR(250) = NULL,
	@INPUT_FILE_PATH VARCHAR(250) = NULL, 
	@OUTPUT_FOLDER_PATH VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- CREAMOS UNA VARIABLE PARA ARMAR EL COMANDO
	DECLARE @COPY_TO_LOCAL_COMMAND VARCHAR(1000) = NULL
	DECLARE @COPY_TO_ORIGINAL_COMMAND VARCHAR(1000) = NULL
	DECLARE @DIARIZATE_COMMAND VARCHAR(1000) = NULL
	DECLARE @DELETE_FROM_LOCAL_INPUT VARCHAR(1000) = NULL
	DECLARE @DELETE_FROM_LOCAL_OUTPUT VARCHAR(1000) = NULL

	DECLARE @LOCAL_C_INPUT_FOLDER VARCHAR(200) = @APP_PATH + '/input'
	DECLARE @LOCAL_C_OUTPUT_FOLDER VARCHAR(200) = @APP_PATH + '/output'
	DECLARE @INPUT_FILE_NAME VARCHAR(250) = NULL

	--SET @COMMAND = 'C:/diarization/inConcertDiarization/inConcertDiarization.exe -i G:/Ftp_Volcado/Repositorio/diarization/inConcertDiarization/source/input/ENTRANTE.wav -o G:/Ftp_Volcado/Repositorio/diarization/inConcertDiarization/source/output -d 1'
	-- xp_cmdshell 'C:\diarization\inConcertDiarization\inConcertDiarization.exe -i C:\diarization\inConcertDiarization\source\input\ENTRANTE.wav -o C:\diarization\inConcertDiarization\source\output -d 1';
	
	-- CREAMOS UNA CTE PARA SEPARAR LAS PARTES DE LA RUTA DE INPUT
	;WITH CTE_INPUT_SPLIT AS (
		SELECT Value 'VAL', 
				ROW_NUMBER() OVER (ORDER BY (SELECT 1)) 'RN' 
			--FROM STRING_SPLIT('G:/Ftp_Volcado/Repositorio/diarization/inConcertDiarization/source/input/ENTRANTE.wav','/')
			FROM STRING_SPLIT(@INPUT_FILE_PATH, '/')
	)

	-- GUARDAMOS EN VARIABLE EL NOMBRE DEL ARCHIVO INPUT
	SELECT TOP 1 @INPUT_FILE_NAME = [VAL] 
		FROM CTE_INPUT_SPLIT 
		ORDER BY [RN] DESC

	-- COMPIAMOS EL ARCHIVO A LA CARPEA DE INPUT CUANDO LAS RUTAS SON DIFERENTES
	IF @INPUT_FILE_PATH <> (@LOCAL_C_INPUT_FOLDER + '/' + @INPUT_FILE_NAME)
	BEGIN
		-- COPIAMOS EL ARCHIVO INPUT DE LA RUTA RECIBIDA A LA CARPETA INPUT LOCAL
		SET @COPY_TO_LOCAL_COMMAND = 'copy ' + @INPUT_FILE_PATH + ' ' +  @LOCAL_C_INPUT_FOLDER + '/' + @INPUT_FILE_NAME + ' '
		SET @COPY_TO_LOCAL_COMMAND = REPLACE(@COPY_TO_LOCAL_COMMAND, '/', '\')
	
		-- EJECUTAMOS EL COMANDO
		EXEC('xp_cmdshell ''' +  @COPY_TO_LOCAL_COMMAND + '''')
	END
	ELSE
	BEGIN
		SELECT 1
	END

	-- ARMAMOS EL COMANDO QUE MUEVE A LA CARPETA LOCAL Y DIARIZAMOS
	--SET @COMMAND = @APP_PATH + '/inConcertDiarization.exe -i ' + @INPUT_FILE_PATH + ' -o ' + @OUTPUT_FOLDER_PATH + ' -d 1';
	--SET @DIARIZATE_COMMAND = 'cd ' + @LOCAL_C_FOLDER + ' & ' + @APP_PATH + '/inConcertDiarization.exe -i input/' + @INPUT_FILE_NAME + ' -o output '
	SET @DIARIZATE_COMMAND = 'cd ' + @APP_PATH + ' & inConcertDiarization.exe -i input/' + @INPUT_FILE_NAME + ' -o output -d 1'
	
	-- EJECUTAMOS EL COMANDO
	EXEC('xp_cmdshell ''' +  @DIARIZATE_COMMAND + '''')

	-- COMPIAMOS EL ARCHIVO A LA CARPEA DE INPUT CUANDO LAS RUTAS SON DIFERENTES
	IF @INPUT_FILE_PATH <> (@LOCAL_C_INPUT_FOLDER + '/' + @INPUT_FILE_NAME)
	BEGIN
		-- COPIAMOS EL ARCHIVO OUTPUT DE LA RUTA LOCAL A LA CARPETA OUTPUT RECIBIDA
		SET @COPY_TO_ORIGINAL_COMMAND = 'copy ' + @LOCAL_C_OUTPUT_FOLDER + '/' + @INPUT_FILE_NAME +' ' +  @OUTPUT_FOLDER_PATH + '/' + @INPUT_FILE_NAME
		SET @COPY_TO_ORIGINAL_COMMAND = REPLACE(@COPY_TO_ORIGINAL_COMMAND, '/', '\')

		-- EJECUTAMOS EL COMANDO
		EXEC('xp_cmdshell ''' +  @COPY_TO_ORIGINAL_COMMAND + '''')

		-- REMOVEMOS LOS ARCHIVOS DE INPUT Y OUTPUT LOCAL
		SET @DELETE_FROM_LOCAL_INPUT = 'del ' + @LOCAL_C_INPUT_FOLDER + '/' + @INPUT_FILE_NAME
		SET @DELETE_FROM_LOCAL_OUTPUT = 'del ' + @LOCAL_C_OUTPUT_FOLDER + '/' + @INPUT_FILE_NAME
	
		SET @DELETE_FROM_LOCAL_INPUT = REPLACE(@DELETE_FROM_LOCAL_INPUT, '/', '\')
		SET @DELETE_FROM_LOCAL_OUTPUT = REPLACE(@DELETE_FROM_LOCAL_OUTPUT, '/', '\')
	
		EXEC('xp_cmdshell ''' +  @DELETE_FROM_LOCAL_INPUT + '''')
		EXEC('xp_cmdshell ''' +  @DELETE_FROM_LOCAL_OUTPUT + '''')
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Actualizando [dbo].[GetAbilityEvaluationFormats]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAbilityEvaluationFormats]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[ReportByDetailAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportByDetailAgent]';


GO
PRINT N'Actualizando [dbo].[ReportBySummaryAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportBySummaryAgent]';


GO
PRINT N'Actualizando [dbo].[SaveHistoricEvaluationPlanData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveHistoricEvaluationPlanData]';


GO
PRINT N'Actualizando [dbo].[SaveEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationPlan]';


GO
PRINT N'Actualización completada.';


GO
