PRINT N'Altering Function [dbo].[GetProcessByName]...';
GO

ALTER PROCEDURE [dbo].[GetProcessByName] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[Name]						    'name',
		[Description]					'description',
		[ClientId]						'clientId',
		[Status]						'status',
		[StartDate]						'startDate',
		[EndDate]						'endDate',
		[MinDurationTime]				'minDurationTime',
		[MaxDurationTime]				'maxDurationTime',
		[Language]						'language',
		[DictionaryId]					'dictionaryId',
		IIF (
			[DictionaryId] IS NULL, 
			CONVERT(BIT, 0), 
			CONVERT(BIT, 1)
		)								'useDictionary',
		[Environment]					'environment',
		[QueryId]						'queryId',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM [Process] (NOLOCK)
	WHERE [Name] = @Name
      AND [VCC] = @VCC
	
	SET NOCOUNT OFF
END

